registerOutputEvent("fxDtsBrick", "makeLauncher", "int 500 30000 2000	int 0 15000 200	list All 0 Red-White-Blue 1	vector", 1);
registerOutputEvent("fxDtsBrick", "cancelLauncher", "", 0);

function fxDtsBrick::cancelLauncher(%brick)
{ cancel(%brick.launcherSched); }

function fxDtsBrick::fireLauncher(%brick, %delay, %var, %type, %spread, %cl)
{
	cancel(%brick.launcherSched);
	if(!isObject(%cl))
		return;
	switch(%type)
	{
		case 0:
			%brick.spawnProjectile("0 0 30", getFirework(getRandom(0, 7)), %spread, 1, %cl);
		case 1:
			%rand = getRandom(0, 2);
			switch(%rand)
			{
				case 2: %brick.spawnProjectile("0 0 30", getFirework(0), %spread, 1, %cl);
				default: %brick.spawnProjectile("0 0 30", getFirework(%rand + 5), %spread, 1, %cl);
			}
	}
	%brick.launcherSched = %brick.schedule(%delay + getRandom(-%var, %var), "fireLauncher", %delay, %var, %type, %spread, %cl);
}

function fxDtsBrick::makeLauncher(%brick, %delay, %var, %type, %spread, %cl)
{
	if(%var > %delay / 2)
	{ %var = %delay / 2; }
	%cl.chatMessage("\c6Started a launcher with an interval of "@%delay@" and a variance of "@%var@".");
	%brick.fireLauncher(%delay, %var, %type, %spread, %cl);
}

function getFirework(%num)
{
	switch(%num)
	{
		case 0: return BlueFireworkProjectile.getID();
		case 1: return GreenFireworkProjectile.getID();
		case 2: return GreyFireworkProjectile.getID();
		case 3: return LBlueFireworkProjectile.getID();
		case 4: return PinkFireworkProjectile.getID();
		case 5: return RedFireworkProjectile.getID();
		case 6: return WhiteFireworkProjectile.getID();
		case 7: return YellowFireworkProjectile.getID();
		default: return WhiteFireworkProjectile.getID();
	}
}